/*******************************************************************************
 * Copyright (c) 2001, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.jst.j2ee.model.internal.validation;




/**
 * Message key constants for WAR validation.
 */
public interface WARMessageConstants extends org.eclipse.jst.j2ee.model.internal.validation.J2EEMessageConstants {
	public static final String WAR_VALIDATOR_ID = "WAR_VALIDATOR"; //$NON-NLS-1$
	public static final String WAR_MODEL_NAME = "WAR_VALIDATION"; //$NON-NLS-1$
	public static final String ERROR_WAR_VALIDATION_FAILED = "ERROR_WAR_VALIDATION_FAILED"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_SMALL_ICON = "MESSAGE_WAR_VALIDATION_SMALL_ICON"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_LARGE_ICON = "MESSAGE_WAR_VALIDATION_LARGE_ICON"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_BROKEN_SERVLET_MAPPING = "MESSAGE_WAR_VALIDATION_BROKEN_SERVLET_MAPPING"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_MISSING_JSP = "MESSAGE_WAR_VALIDATION_MISSING_JSP"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_MISSING_TLD = "MESSAGE_WAR_VALIDATION_MISSING_TLD"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_MISSING_WELCOME_FILE = "MESSAGE_WAR_VALIDATION_MISSING_WELCOME_FILE"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_NO_WELCOME_FILE = "MESSAGE_WAR_VALIDATION_NO_WELCOME_FILE"; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_URL = "MESSAGE_WAR_VALIDATION_INVALID_URL" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_DUPLICATE_MAPPING = "MESSAGE_WAR_VALIDATION_DUPLICATE_MAPPING" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_DUPLICATE_SERVLET = "MESSAGE_WAR_VALIDATION_DUPLICATE_SERVLET" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_DUPLICATE_EJB_REF = "MESSAGE_WAR_VALIDATION_DUPLICATE_EJB_REF" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_SESSION_TIMEOUT = "MESSAGE_WAR_VALIDATION_SESSION_TIMEOUT" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_DUPLICATE_ENTRY = "MESSAGE_WAR_VALIDATION_DUPLICATE_ENTRY" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_EMPTY_ENTRY = "MESSAGE_WAR_VALIDATION_EMPTY_ENTRY" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_SEC_ROLE = "MESSAGE_WAR_VALIDATION_INVALID_SEC_ROLE" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_SEC_ROLE_NAME = "MESSAGE_WAR_VALIDATION_INVALID_SEC_ROLE_NAME" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_HTTP_CMD = "MESSAGE_WAR_VALIDATION_INVALID_HTTP_CMD" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_TRANSPORT = "MESSAGE_WAR_VALIDATION_INVALID_TRANSPORT" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_JSPFILE_REF = "MESSAGE_WAR_VALIDATION_INVALID_JSPFILE_REF" ; //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_WELCOME_FILE = "MESSAGE_WAR_VALIDATION_INVALID_WELCOME_FILE" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_ERROR_PAGE = "MESSAGE_WAR_VALIDATION_INVALID_ERROR_PAGE" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_INVALID_AUTH_METHOD = "MESSAGE_WAR_VALIDATION_INVALID_AUTH_METHOD" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_IGNORE_FORM_LOGIN = "MESSAGE_WAR_VALIDATION_IGNORE_FORM_LOGIN" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_RES_AUTH_REQUIRED_22 = "MESSAGE_WAR_VALIDATION_RES_AUTH_REQUIRED_22" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_RES_AUTH_REQUIRED_23 = "MESSAGE_WAR_VALIDATION_RES_AUTH_REQUIRED_23" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_RES_AUTH_INVALID_22 = "MESSAGE_WAR_VALIDATION_RES_AUTH_INVALID_22" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_RES_AUTH_INVALID_23 = "MESSAGE_WAR_VALIDATION_RES_AUTH_INVALID_23" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_DUPLICATE_FILTER = "MESSAGE_WAR_VALIDATION_DUPLICATE_FILTER" ;	 //$NON-NLS-1$
	public static final String MESSAGE_WAR_VALIDATION_BROKEN_FILTER_MAPPING = "MESSAGE_WAR_VALIDATION_BROKEN_FILTER_MAPPING" ; //$NON-NLS-1$
	public static final String ERROR_EAR_DUPLICATE_ROLES = "ERROR_EAR_DUPLICATE_ROLES"; //$NON-NLS-1$
	public static final String ERROR_EAR_UNCONTAINED_MODULE_FILE_EXCEPTION = "ERROR_EAR_UNCONTAINED_MODULE_FILE_EXCEPTION"; //$NON-NLS-1$
	public static final String ERROR_INVALID_WAR_FILE = "ERROR_INVALID_WAR_FILE"; //$NON-NLS-1$
	public static final String WAR_DD_PARSE_LINECOL = "WAR_DD_PARSE_LINECOL"; //$NON-NLS-1$
	public static final String WAR_DD_PARSE_LINE = "WAR_DD_PARSE_LINE"; //$NON-NLS-1$
	public static final String WAR_DD_CANNOT_OPEN_DD = "WAR_DD_CANNOT_OPEN_DD"; //$NON-NLS-1$
	public static final String WAR_DD_PARSE_NOINFO = "WAR_DD_PARSE_NOINFO"; //$NON-NLS-1$
	public static String ERROR_EAR_INVALID_CONTEXT_ROOT = "ERROR_EAR_INVALID_CONTEXT_ROOT"; //$NON-NLS-1$
	public static String MESSAGE_WAR_VALIDATION_INVALID_RES_SHARING_SCOPE = "MESSAGE_WAR_VALIDATION_INVALID_RES_SHARING_SCOPE"; //$NON-NLS-1$
	public static String MESSAGE_WAR_VALIDATION_INVALID_ENV_ENTRY = "MESSAGE_WAR_VALIDATION_INVALID_ENV_ENTRY"; //$NON-NLS-1$
	public static String MESSAGE_WAR_VALIDATION_INVALID_ERROR_CODE	 = "MESSAGE_WAR_VALIDATION_INVALID_ERROR_CODE"; //$NON-NLS-1$
	public static String MESSAGE_WAR_VALIDATION_MISSING_WLP_PROJECT = "MESSAGE_WAR_VALIDATION_MISSING_WLP_PROJECT"; //$NON-NLS-1$		
	public static String MESSAGE_WAR_VALIDATION_INVALID_EXCEPTION_TYPE = "MESSAGE_WAR_VALIDATION_INVALID_EXCEPTION_TYPE"; //$NON-NLS-1$		
	public static String MESSAGE_WAR_VALIDATION_CONFLICTING_WLP_PROJECT = "MESSAGE_WAR_VALIDATION_CONFLICTING_WLP_PROJECT";  //$NON-NLS-1$
	public static String MESSAGE_WAR_VALIDATION_INVALID_EJB_REF_TYPE = "MESSAGE_WAR_VALIDATION_INVALID_EJB_REF_TYPE";  //$NON-NLS-1$
	//J2EE 14 Messages
	public static String MESSAGE_URL_PATTERN_END_WITH_CARRAIGE_RETURN = "MESSAGE_URL_PATTERN_END_WITH_CARRAIGE_RETURN"; //$NON-NLS-1$
	
	
	
	}
