/*******************************************************************************
 * Copyright (c) 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.wst.css.core.internal.metamodel.util;

public interface CSSKeywordID {

	final static String K_100 = "100"; //$NON-NLS-1$
	final static String K_200 = "200"; //$NON-NLS-1$
	final static String K_300 = "300"; //$NON-NLS-1$
	final static String K_400 = "400"; //$NON-NLS-1$
	final static String K_500 = "500"; //$NON-NLS-1$
	final static String K_600 = "600"; //$NON-NLS-1$
	final static String K_700 = "700"; //$NON-NLS-1$
	final static String K_800 = "800"; //$NON-NLS-1$
	final static String K_900 = "900"; //$NON-NLS-1$
	final static String K_ABOVE = "above"; //$NON-NLS-1$
	final static String K_ABSOLUTE = "absolute"; //$NON-NLS-1$
	final static String K_ACTIVEBORDER = "ActiveBorder"; //$NON-NLS-1$
	final static String K_ACTIVECAPTION = "ActiveCaption"; //$NON-NLS-1$
	final static String K_ALL = "all"; //$NON-NLS-1$
	final static String K_ALWAYS = "always"; //$NON-NLS-1$
	final static String K_APPWORKSPACE = "AppWorkspace"; //$NON-NLS-1$
	final static String K_AQUA = "aqua"; //$NON-NLS-1$
	final static String K_ARMENIAN = "armenian"; //$NON-NLS-1$
	final static String K_AUTO = "auto"; //$NON-NLS-1$
	final static String K_AVOID = "avoid"; //$NON-NLS-1$
	final static String K_BACKGROUND = "Background"; //$NON-NLS-1$
	final static String K_BASELINE = "baseline"; //$NON-NLS-1$
	final static String K_BEHIND = "behind"; //$NON-NLS-1$
	final static String K_BELOW = "below"; //$NON-NLS-1$
	final static String K_BIDI_OVERRIDE = "bidi-override"; //$NON-NLS-1$
	final static String K_BLACK = "black"; //$NON-NLS-1$
	final static String K_BLINK = "blink"; //$NON-NLS-1$
	final static String K_BLOCK = "block"; //$NON-NLS-1$
	final static String K_BLUE = "blue"; //$NON-NLS-1$
	final static String K_BOLD = "bold"; //$NON-NLS-1$
	final static String K_BOLDER = "bolder"; //$NON-NLS-1$
	final static String K_BOTH = "both"; //$NON-NLS-1$
	final static String K_BOTTOM = "bottom"; //$NON-NLS-1$
	final static String K_BUTTONFACE = "ButtonFace"; //$NON-NLS-1$
	final static String K_BUTTONHIGHLIGHT = "ButtonHighlight"; //$NON-NLS-1$
	final static String K_BUTTONSHADOW = "ButtonShadow"; //$NON-NLS-1$
	final static String K_BUTTONTEXT = "ButtonText"; //$NON-NLS-1$
	final static String K_CAPITALIZE = "capitalize"; //$NON-NLS-1$
	final static String K_CAPTION = "caption"; //$NON-NLS-1$
	final static String K_CAPTIONTEXT = "CaptionText"; //$NON-NLS-1$
	final static String K_CENTER = "center"; //$NON-NLS-1$
	final static String K_CENTER_LEFT = "center-left"; //$NON-NLS-1$
	final static String K_CENTER_RIGHT = "center-right"; //$NON-NLS-1$
	final static String K_CHILD = "child"; //$NON-NLS-1$
	final static String K_CIRCLE = "circle"; //$NON-NLS-1$
	final static String K_CJK_IDEOGRAPHIC = "cjk-ideographic"; //$NON-NLS-1$
	final static String K_CLOSE_QUOTE = "close-quote"; //$NON-NLS-1$
	final static String K_CODE = "code"; //$NON-NLS-1$
	final static String K_CONDENSED = "condensed"; //$NON-NLS-1$
	final static String K_COLLAPSE = "collapse"; //$NON-NLS-1$
	final static String K_COMPACT = "compact"; //$NON-NLS-1$
	final static String K_CONTINUOUS = "continuous"; //$NON-NLS-1$
	final static String K_CROP = "crop"; //$NON-NLS-1$
	final static String K_CROSS = "cross"; //$NON-NLS-1$
	final static String K_CROSSHAIR = "crosshair"; //$NON-NLS-1$
	final static String K_CURSIVE = "cursive"; //$NON-NLS-1$
	final static String K_DASHED = "dashed"; //$NON-NLS-1$
	final static String K_DECIMAL = "decimal"; //$NON-NLS-1$
	final static String K_DECIMAL_LEADING_ZERO = "decimal-leading-zero"; //$NON-NLS-1$
	final static String K_DEFAULT = "default"; //$NON-NLS-1$
	final static String K_DIGITS = "digits"; //$NON-NLS-1$
	final static String K_DISC = "disc"; //$NON-NLS-1$
	final static String K_DOTTED = "dotted"; //$NON-NLS-1$
	final static String K_DOUBLE = "double"; //$NON-NLS-1$
	final static String K_E_RESIZE = "e-resize"; //$NON-NLS-1$
	final static String K_EMBED = "embed"; //$NON-NLS-1$
	final static String K_EXPANDED = "expanded"; //$NON-NLS-1$
	final static String K_EXTRA_CONDENSED = "extra-condensed"; //$NON-NLS-1$
	final static String K_EXTRA_EXPANDED = "extra-expanded"; //$NON-NLS-1$
	final static String K_FANTASY = "fantasy"; //$NON-NLS-1$
	final static String K_FAR_LEFT = "far-left"; //$NON-NLS-1$
	final static String K_FAR_RIGHT = "far-right"; //$NON-NLS-1$
	final static String K_FAST = "fast"; //$NON-NLS-1$
	final static String K_FASTER = "faster"; //$NON-NLS-1$
	final static String K_FEMALE = "female"; //$NON-NLS-1$
	final static String K_FIXED = "fixed"; //$NON-NLS-1$
	final static String K_FUCHSIA = "fuchsia"; //$NON-NLS-1$
	final static String K_GEORGIAN = "georgian"; //$NON-NLS-1$
	final static String K_GRAY = "gray"; //$NON-NLS-1$
	final static String K_GRAYTEXT = "GrayText"; //$NON-NLS-1$
	final static String K_GREEN = "green"; //$NON-NLS-1$
	final static String K_GROOVE = "groove"; //$NON-NLS-1$
	final static String K_HEBREW = "hebrew"; //$NON-NLS-1$
	final static String K_HELP = "help"; //$NON-NLS-1$
	final static String K_HIDDEN = "hidden"; //$NON-NLS-1$
	final static String K_HIDE = "hide"; //$NON-NLS-1$
	final static String K_HIGH = "high"; //$NON-NLS-1$
	final static String K_HIGHLIGHT = "Highlight"; //$NON-NLS-1$
	final static String K_HIGHLIGHTTEXT = "HighlightText"; //$NON-NLS-1$
	final static String K_HIGHER = "higher"; //$NON-NLS-1$
	final static String K_HIRAGANA = "hiragana"; //$NON-NLS-1$
	final static String K_HIRAGANA_IROHA = "hiragana-iroha"; //$NON-NLS-1$
	final static String K_ICON = "icon"; //$NON-NLS-1$
	final static String K_INACTIVEBORDER = "InactiveBorder"; //$NON-NLS-1$
	final static String K_INACTIVECAPTION = "InactiveCaption"; //$NON-NLS-1$
	final static String K_INACTIVECAPTIONTEXT = "InactiveCaptionText"; //$NON-NLS-1$
	final static String K_INFOBACKGROUND = "InfoBackground"; //$NON-NLS-1$
	final static String K_INFOTEXT = "InfoText"; //$NON-NLS-1$
	final static String K_INLINE = "inline"; //$NON-NLS-1$
	final static String K_INLINE_TABLE = "inline-table"; //$NON-NLS-1$
	final static String K_INSET = "inset"; //$NON-NLS-1$
	final static String K_INSIDE = "inside"; //$NON-NLS-1$
	final static String K_INVERT = "invert"; //$NON-NLS-1$
	final static String K_ITALIC = "italic"; //$NON-NLS-1$
	final static String K_JUSTIFY = "justify"; //$NON-NLS-1$
	final static String K_KATAKANA = "katakana"; //$NON-NLS-1$
	final static String K_KATAKANA_IROHA = "katakana-iroha"; //$NON-NLS-1$
	final static String K_LANDSCAPE = "landscape"; //$NON-NLS-1$
	final static String K_LARGE = "large"; //$NON-NLS-1$
	final static String K_LARGER = "larger"; //$NON-NLS-1$
	final static String K_LEFT = "left"; //$NON-NLS-1$
	final static String K_LEFT_SIDE = "left-side"; //$NON-NLS-1$
	final static String K_LEFTWARDS = "leftwards"; //$NON-NLS-1$
	final static String K_LEVEL = "level"; //$NON-NLS-1$
	final static String K_LIGHTER = "lighter"; //$NON-NLS-1$
	final static String K_LIME = "lime"; //$NON-NLS-1$
	final static String K_LINE_THROUGH = "line-through"; //$NON-NLS-1$
	final static String K_LIST_ITEM = "list-item"; //$NON-NLS-1$
	final static String K_LOUD = "loud"; //$NON-NLS-1$
	final static String K_LOW = "low"; //$NON-NLS-1$
	final static String K_LOWER = "lower"; //$NON-NLS-1$
	final static String K_LOWER_ALPHA = "lower-alpha"; //$NON-NLS-1$
	final static String K_LOWER_GREEK = "lower-greek"; //$NON-NLS-1$
	final static String K_LOWER_LATIN = "lower-latin"; //$NON-NLS-1$
	final static String K_LOWER_ROMAN = "lower-roman"; //$NON-NLS-1$
	final static String K_LOWERCASE = "lowercase"; //$NON-NLS-1$
	final static String K_LTR = "ltr"; //$NON-NLS-1$
	final static String K_MALE = "male"; //$NON-NLS-1$
	final static String K_MARKER = "marker"; //$NON-NLS-1$
	final static String K_MAROON = "maroon"; //$NON-NLS-1$
	final static String K_MEDIUM = "medium"; //$NON-NLS-1$
	final static String K_MENU = "menu"; //$NON-NLS-1$
	final static String K_MENUTEXT = "MenuText"; //$NON-NLS-1$
	final static String K_MESSAGE_BOX = "message-box"; //$NON-NLS-1$
	final static String K_MIDDLE = "middle"; //$NON-NLS-1$
	final static String K_MIX = "mix"; //$NON-NLS-1$
	final static String K_MONOSPACE = "monospace"; //$NON-NLS-1$
	final static String K_MOVE = "move"; //$NON-NLS-1$
	final static String K_N_RESIZE = "n-resize"; //$NON-NLS-1$
	final static String K_NARROWER = "narrower"; //$NON-NLS-1$
	final static String K_NAVY = "navy"; //$NON-NLS-1$
	final static String K_NE_RESIZE = "ne-resize"; //$NON-NLS-1$
	final static String K_NO_CLOSE_QUOTE = "no-close-quote"; //$NON-NLS-1$
	final static String K_NO_OPEN_QUOTE = "no-open-quote"; //$NON-NLS-1$
	final static String K_NO_REPEAT = "no-repeat"; //$NON-NLS-1$
	final static String K_NONE = "none"; //$NON-NLS-1$
	final static String K_NORMAL = "normal"; //$NON-NLS-1$
	final static String K_NOWRAP = "nowrap"; //$NON-NLS-1$
	final static String K_NW_RESIZE = "nw-resize"; //$NON-NLS-1$
	final static String K_OBLIQUE = "oblique"; //$NON-NLS-1$
	final static String K_OLIVE = "olive"; //$NON-NLS-1$
	final static String K_ONCE = "once"; //$NON-NLS-1$
	final static String K_OPEN_QUOTE = "open-quote"; //$NON-NLS-1$
	final static String K_OUTSET = "outset"; //$NON-NLS-1$
	final static String K_OUTSIDE = "outside"; //$NON-NLS-1$
	final static String K_OVERLINE = "overline"; //$NON-NLS-1$
	final static String K_POINTER = "pointer"; //$NON-NLS-1$
	final static String K_PORTRAIT = "portrait"; //$NON-NLS-1$
	final static String K_PRE = "pre"; //$NON-NLS-1$
	final static String K_PURPLE = "purple"; //$NON-NLS-1$
	final static String K_RED = "red"; //$NON-NLS-1$
	final static String K_RELATIVE = "relative"; //$NON-NLS-1$
	final static String K_REPEAT = "repeat"; //$NON-NLS-1$
	final static String K_REPEAT_X = "repeat-x"; //$NON-NLS-1$
	final static String K_REPEAT_Y = "repeat-y"; //$NON-NLS-1$
	final static String K_RIDGE = "ridge"; //$NON-NLS-1$
	final static String K_RIGHT = "right"; //$NON-NLS-1$
	final static String K_RIGHT_SIDE = "right-side"; //$NON-NLS-1$
	final static String K_RIGHTWARDS = "rightwards"; //$NON-NLS-1$
	final static String K_RTL = "rtl"; //$NON-NLS-1$
	final static String K_RUN_IN = "run-in"; //$NON-NLS-1$
	final static String K_S_RESIZE = "s-resize"; //$NON-NLS-1$
	final static String K_SANS_SERIF = "sans-serif"; //$NON-NLS-1$
	final static String K_SCROLL = "scroll"; //$NON-NLS-1$
	final static String K_SCROLLBAR = "Scrollbar"; //$NON-NLS-1$
	final static String K_SE_RESIZE = "se-resize"; //$NON-NLS-1$
	final static String K_SEMI_CONDENSED = "semi-condensed"; //$NON-NLS-1$
	final static String K_SEMI_EXPANDED = "semi-expanded"; //$NON-NLS-1$
	final static String K_SEPARATE = "separate"; //$NON-NLS-1$
	final static String K_SERIF = "serif"; //$NON-NLS-1$
	final static String K_SHOW = "show"; //$NON-NLS-1$
	final static String K_SILENT = "silent"; //$NON-NLS-1$
	final static String K_SILVER = "silver"; //$NON-NLS-1$
	final static String K_SLOW = "slow"; //$NON-NLS-1$
	final static String K_SLOWER = "slower"; //$NON-NLS-1$
	final static String K_SMALL = "small"; //$NON-NLS-1$
	final static String K_SMALL_CAPS = "small-caps"; //$NON-NLS-1$
	final static String K_SMALL_CAPTION = "small-caption"; //$NON-NLS-1$
	final static String K_SMALLER = "smaller"; //$NON-NLS-1$
	final static String K_SOFT = "soft"; //$NON-NLS-1$
	final static String K_SOLID = "solid"; //$NON-NLS-1$
	final static String K_SPELL_OUT = "spell-out"; //$NON-NLS-1$
	final static String K_SQUARE = "square"; //$NON-NLS-1$
	final static String K_STATIC = "static"; //$NON-NLS-1$
	final static String K_STATUS_BAR = "status-bar"; //$NON-NLS-1$
	final static String K_SUB = "sub"; //$NON-NLS-1$
	final static String K_SUPER = "super"; //$NON-NLS-1$
	final static String K_SW_RESIZE = "sw-resize"; //$NON-NLS-1$
	final static String K_TABLE = "table"; //$NON-NLS-1$
	final static String K_TABLE_CAPTION = "table-caption"; //$NON-NLS-1$
	final static String K_TABLE_CELL = "table-cell"; //$NON-NLS-1$
	final static String K_TABLE_COLUMN = "table-column"; //$NON-NLS-1$
	final static String K_TABLE_COLUMN_GROUP = "table-column-group"; //$NON-NLS-1$
	final static String K_TABLE_FOOTER_GROUP = "table-footer-group"; //$NON-NLS-1$
	final static String K_TABLE_HEADER_GROUP = "table-header-group"; //$NON-NLS-1$
	final static String K_TABLE_ROW = "table-row"; //$NON-NLS-1$
	final static String K_TABLE_ROW_GROUP = "table-row-group"; //$NON-NLS-1$
	final static String K_TEAL = "teal"; //$NON-NLS-1$
	final static String K_TEXT = "text"; //$NON-NLS-1$
	final static String K_TEXT_TOP = "text-top"; //$NON-NLS-1$
	final static String K_TEXT_BOTTOM = "text-bottom"; //$NON-NLS-1$
	final static String K_THICK = "thick"; //$NON-NLS-1$
	final static String K_THIN = "thin"; //$NON-NLS-1$
	final static String K_THREEDDARKSHADOW = "ThreeDDarkShadow"; //$NON-NLS-1$
	final static String K_THREEDFACE = "ThreeDFace"; //$NON-NLS-1$
	final static String K_THREEDHIGHLIGHT = "ThreeDHighlight"; //$NON-NLS-1$
	final static String K_THREEDLIGHTSHADOW = "ThreeDLightShadow"; //$NON-NLS-1$
	final static String K_THREEDSHADOW = "ThreeDShadow"; //$NON-NLS-1$
	final static String K_TOP = "top"; //$NON-NLS-1$
	final static String K_TRANSPARENT = "transparent"; //$NON-NLS-1$
	final static String K_ULTRA_CONDENSED = "ultra-condensed"; //$NON-NLS-1$
	final static String K_ULTRA_EXPANDED = "ultra-expanded"; //$NON-NLS-1$
	final static String K_UNDERLINE = "underline"; //$NON-NLS-1$
	final static String K_UPPER_ALPHA = "upper-alpha"; //$NON-NLS-1$
	final static String K_UPPER_LATIN = "upper-latin"; //$NON-NLS-1$
	final static String K_UPPER_ROMAN = "upper-roman"; //$NON-NLS-1$
	final static String K_UPPERCASE = "uppercase"; //$NON-NLS-1$
	final static String K_VISIBLE = "visible"; //$NON-NLS-1$
	final static String K_W_RESIZE = "w-resize"; //$NON-NLS-1$
	final static String K_WAIT = "wait"; //$NON-NLS-1$
	final static String K_WHITE = "white"; //$NON-NLS-1$
	final static String K_WIDER = "wider"; //$NON-NLS-1$
	final static String K_WINDOW = "Window"; //$NON-NLS-1$
	final static String K_WINDOWFRAME = "WindowFrame"; //$NON-NLS-1$
	final static String K_WINDOWTEXT = "WindowText"; //$NON-NLS-1$
	final static String K_X_FAST = "x-fast"; //$NON-NLS-1$
	final static String K_X_HIGH = "x-high"; //$NON-NLS-1$
	final static String K_X_LARGE = "x-large"; //$NON-NLS-1$
	final static String K_X_LOUD = "x-loud"; //$NON-NLS-1$
	final static String K_X_LOW = "x-low"; //$NON-NLS-1$
	final static String K_X_SLOW = "x-slow"; //$NON-NLS-1$
	final static String K_X_SMALL = "x-small"; //$NON-NLS-1$
	final static String K_X_SOFT = "x-soft"; //$NON-NLS-1$
	final static String K_XX_SMALL = "xx-small"; //$NON-NLS-1$
	final static String K_XX_LARGE = "xx-large"; //$NON-NLS-1$
	final static String K_YELLOW = "yellow"; //$NON-NLS-1$
}