/*******************************************************************************
 * Copyright (c) 2000, 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.wst.wsdl.binding.soap;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.wst.wsdl.binding.soap.SOAPPackage
 * @generated
 */
public interface SOAPFactory extends EFactory{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @generated
   */
	SOAPFactory eINSTANCE = new org.eclipse.wst.wsdl.binding.soap.internal.impl.SOAPFactoryImpl();

  /**
   * Returns a new object of class '<em>Binding</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Binding</em>'.
   * @generated
   */
	SOAPBinding createSOAPBinding();

  /**
   * Returns a new object of class '<em>Body</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Body</em>'.
   * @generated
   */
	SOAPBody createSOAPBody();

  /**
   * Returns a new object of class '<em>Header Base</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Header Base</em>'.
   * @generated
   */
	SOAPHeaderBase createSOAPHeaderBase();

  /**
   * Returns a new object of class '<em>Fault</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Fault</em>'.
   * @generated
   */
	SOAPFault createSOAPFault();

  /**
   * Returns a new object of class '<em>Operation</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Operation</em>'.
   * @generated
   */
	SOAPOperation createSOAPOperation();

  /**
   * Returns a new object of class '<em>Address</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Address</em>'.
   * @generated
   */
	SOAPAddress createSOAPAddress();

  /**
   * Returns a new object of class '<em>Header Fault</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Header Fault</em>'.
   * @generated
   */
	SOAPHeaderFault createSOAPHeaderFault();

  /**
   * Returns a new object of class '<em>Header</em>'.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return a new object of class '<em>Header</em>'.
   * @generated
   */
	SOAPHeader createSOAPHeader();

  /*
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated NOT
   */
	//SOAPPackage getSOAPPackage();

} //SOAPFactory
